#include <iostream>
#include <cstring>
#include <cctype>
#include<cmath>


using namespace std;

const int MAX = 100 ; //MAX is the string of input
class infix // Class definition and declaaration of the members
{
	private :
		char postfix[MAX], stack[MAX] ;
		char *s, *t ;
		int top ;
	public :
		infix( ) ;
		void setexpr ( char *str ) ;// setting the expression assigned to 's'
		void push ( char c ) ;
		char pop( ) ;
		void convert( ) ;
		int priority ( char c ) ;
		void show( ) ;
		int EvaluatePostfix();
		int operation(int ,int ,char);
} ;
infix :: infix( )// assignments to variables and functions declaration
{
	top = -1 ;
	strcpy ( postfix, "" ) ;
	strcpy ( stack, "" ) ;
	t = postfix ;
	s = ""  ;
}
//Infix string entered by the user is set as s
void infix :: setexpr ( char *str )
{
	s = str ;
}
void infix :: push ( char c )// function to stack the elements
{
	if ( top == MAX )
		cout << "\nStack is full\n" ;
	else
	{
		top++ ;
		stack[top] = c ;
	}
}
char infix :: pop( )//function to pop .i.e to remove the top most element from the stack
{
	if ( top == -1 )// if stack is empty
	{
		cout << "\nStack is empty\n" ;
		return -1 ;
	}
	else
	{
		char item = stack[top] ;// to pop the element from stack when it is not empty
		top-- ;
		return item ;
	}
}
void infix :: convert( )
{
	while ( *s )// for avoiding the spaces and tabs in the screen
	{
		if ( *s == ' ' || *s == '\t' )
		{
			s++ ;
			continue ;
		}
		if ( isdigit ( *s ) || isalpha ( *s )||*s=='.' )// to increment the postfix string if this condition satisfies
		{
			while ( isdigit ( *s ) || isalpha ( *s )||*s=='.' )
			{
				*t = *s ;
				s++ ;
				t++ ;
			}
		}
		if ( *s == '(' )// precedence of open brace
		{
			push ( *s ) ;
			s++ ;
		}
		char opr ;
		if ( *s == '*' || *s == '+' || *s == '/' || *s == '%' || *s == '-' || *s == '^' )
		{
			if ( top != -1 )
			{
				opr = pop( ) ;
				while ( priority ( opr ) >= priority ( *s ) )
				{
					*t = opr ;
					t++ ;
					opr = pop( ) ;
				}
				push ( opr ) ;
				push ( *s ) ;
			}
			else
				push ( *s ) ;
			s++ ;
		}
		if ( *s == ')' )
		{
			opr = pop( ) ;
			while ( ( opr ) != '(' )
			{
				*t = opr ;
				t++ ;
				opr =  pop( ) ;
			}
			s++ ;
		}
	}
	while ( top != -1 )
	{
		char opr = pop( ) ;
		*t = opr ;
		t++ ;
	}
	*t = '\0' ;
}
int infix :: priority ( char c )// setting the precedence of operators from highest to lowest
{

	if ( c == '^' )
		return 3 ;
	if ( c == '*' || c == '/' || c == '%' )
		return 2 ;
	else
	{
		if ( c == '+' || c == '-' )
			return 1 ;
		else
			return 0 ;
	}
}




void infix :: show( )// member will send the postfix string
{
	cout << postfix ;
}
int main( )
{
	char expr[MAX] ;
	infix call ;

	cout << "\nEnter an expression in infix form: " ;
	cin.getline ( expr, MAX ) ;

	call.setexpr ( expr ) ;
	call.convert( ) ;

	cout << "\nThe postfix expression is: " ;
	call.show( ) ;


}
